#!/bin/bash -e

function run_program()
{
# This function runs the iterator program

	# Remove left over running file
	rm -f running

	# Write to logfile
	echo "" >> logfile
	date >> logfile
	echo "Running iterator with ${@}" >> logfile

	# Run program with passed arguments
	"${myPROG}" "${@}" > "stdout-${4}"

	# Remove left over running file
	rm -f running

	# Rename output file
	mv output.dat "output-${4}.dat"

	# Write to logfile
	echo "Output file: output-${4}.dat" >> logfile
	echo "Standard output: stdout-${4}" >> logfile
}

# Program to run: iterator
myPROG="$(pwd -P)/iterator"

# Parameters that stay the same each run
myFIXED_PARAMS="100 100 1000"

# My current directory
myDIR="$(pwd -P)"

# Temporary directory for me to work in
myTEMP_DIR="$(mktemp -t -d iterator.XXXXXXXXX)"

# Change to temporary directory
cd "${myTEMP_DIR}"

# Run program once for each argument
#  Note: *no* quotes around ${myFIXED_PARAMS}
#        or they'll be interpreted as one argument!
for zzARGS in "${@}" ; do
	run_program ${myFIXED_PARAMS} ${zzARGS}
done

# Copy files back to my directory
cp -fpr . "${myDIR}"

# Go back to my directory
cd "${myDIR}"

# Clean up
rm -rf "${myTEMP_DIR}"
